#include <iostream>
#include <fstream>
#include <string>
#include <cstring>

using namespace std;

//funkcja odpowiedzialna za liczenie wierszy w pliku - nie zmieniac!
int liczenieWierszy(fstream &file)
{
	int i = 0; //ustawia licznik wierszy na 0
	string linia;
	while(getline(file,linia)) //pobiera kolejno linie tekstu z pliku
		i++; //inkrementuje licznik wierszy
	file.clear();
	file.seekg(0); //ustawia kursor na poczatek pliku
	return i; //zwraca liczbe wierszy
}

//funkcja odpowiedzialna za przepisywanie zawartosci pliku do tablicy - nie zmieniac!
void wpisywanie(fstream &file, char **tab, int rozmiar)
{
	string imie;
	for(int i = 0; i < rozmiar; i++)
	{
		getline(file, imie); //pobiera jedno imie z pliku
		tab[i] = new char [imie.length()]; //dostosowuje rozmiar tablicy do dlugosci imienia
		strcpy(tab[i], imie.c_str()); //wpisuje imie do tablicy
	}
}

//funkcja odpowiedzialna za wyswietlanie zawartosci tablicy - nie zmieniac!
void wyswietlanie(char **tab, int rozmiar)
{
	cout << "Imiona zapisane do tablicy i ich rozmiary: " << endl;
	for(int i = 0; i < rozmiar; i++)
	{
		cout << "Imie "<< i+1 << ": " << tab[i] << endl;
		cout << "Rozmiar: " << strlen(tab[i]) << endl; 
		//funkcja strlen() zwraca dlugosc tablicy znakow
	}
}

// funkcja odpowiedzialna za usuwanie zawartosci tablicy - nie zmieniac!
void czyszczenie(char **tab, int rozmiar)
{
	for(int i = 0; i < rozmiar; i++)
	{
		delete [] tab[i];
		tab[i]=NULL;
	}
}

void sortowanie(/*...*/)
{
	/*...*/
}

void zapis(/*...*/)
{
	/*...*/
}

int main()
{
	fstream plik; //uchwyt do pliku
	plik.open("input.txt", ios::in); //otwarcie pliku input.txt jako wejsciowy
	if(!plik.good()) //sprawdzenie czy plik otworzyl sie poprawnie
		return 0;
	int liczbaImion = liczenieWierszy(plik); //wywolanie funkcji obliczajacej dlugosc pliku
	
	char **tablica=NULL;	//tworzenie dwuwymiarowej tablicy dynamicznej
	tablica = new char * [liczbaImion]; 
	
	wpisywanie(plik, tablica, liczbaImion);
	wyswietlanie(tablica, liczbaImion);	
	
	/*... - miejsce na twoj kod*/
	sortowanie(/*...*/);
	//wyswietlanie(/*...*/);
	zapis(/*...*/);
	//czyszczenie(/*...*/);
	/*...*/

	czyszczenie(tablica, liczbaImion); //sprzatanie po tablicy		
	delete [] tablica;
	tablica = NULL;
	plik.close();//zamykanie pliku
	return 0;
}
